// Copyright Epic Games, Inc. All Rights Reserved.

#include "FiveStackPotionGameGameMode.h"
#include "FiveStackPotionGamePlayerController.h"
#include "FiveStackPotionGameCharacter.h"
#include "UObject/ConstructorHelpers.h"

AFiveStackPotionGameGameMode::AFiveStackPotionGameGameMode()
{
	// use our custom PlayerController class
	PlayerControllerClass = AFiveStackPotionGamePlayerController::StaticClass();

	// set default pawn class to our Blueprinted character
	static ConstructorHelpers::FClassFinder<APawn> PlayerPawnBPClass(TEXT("/Game/TopDown/Blueprints/BP_TopDownCharacter"));
	if (PlayerPawnBPClass.Class != nullptr)
	{
		DefaultPawnClass = PlayerPawnBPClass.Class;
	}

	// set default controller to our Blueprinted controller
	static ConstructorHelpers::FClassFinder<APlayerController> PlayerControllerBPClass(TEXT("/Game/TopDown/Blueprints/BP_TopDownPlayerController"));
	if(PlayerControllerBPClass.Class != NULL)
	{
		PlayerControllerClass = PlayerControllerBPClass.Class;
	}
}