// Fill out your copyright notice in the Description page of Project Settings.


#include "Potions.h"
static const int NumOfIngredients = 4;
// Sets default values for this component's properties
UPotions::UPotions()
{
	// Set this component to be initialized when the game starts, and to be ticked every frame.  You can turn these features
	// off to improve performance if you don't need them.
	PrimaryComponentTick.bCanEverTick = true;

	// ...
}


// Called when the game starts
void UPotions::BeginPlay()
{
	Super::BeginPlay();

	UE_LOG(LogTemp, Warning, TEXT("BEGIN"));
	InitIngArr(NumOfIngredients);
	potionBacklog.Init(Empty, 4);
	GEngine->AddOnScreenDebugMessage(-1, 5, FColor::Yellow, FString::FromInt(NumOfIngredients) + " in begin play");
	for (int i = 0; i < 4; i++)
	{
		potionBacklog[i] = Empty;
	}
	CraftPotion();
	// ...
	
}


// Called every frame
void UPotions::TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction)
{
	Super::TickComponent(DeltaTime, TickType, ThisTickFunction);
	// ...
}

void UPotions::CraftPotion() {
	bool wasValid = true;
	TEnumAsByte<FPotionTypes> potionCrafted;
	FString potionID = "5"; // Add a dummy number so that when converted to an integer the zero isnt removed automatically
	GEngine->AddOnScreenDebugMessage(-1, 5, FColor::Yellow, FString::FromInt(NumOfIngredients) + " in craft");
	for (int i = 0; i < NumOfIngredients; i++) {
		potionID = potionID + FString::FromInt(IngredientArr[i]);
		GEngine->AddOnScreenDebugMessage(-1, 5, FColor::Yellow, potionID);
	}
	UE_LOG(LogTemp, Warning, TEXT("%d"), NumOfIngredients);
	UE_LOG(LogTemp, Warning, TEXT("%s"), *potionID);
	int potionIDINT = UKismetStringLibrary::Conv_StringToInt(potionID);
	switch (potionIDINT) {
	case 50210:
		UE_LOG(LogTemp, Warning, TEXT("ACID POTION"));
		potionCrafted = Acid;
		break;
	case 52100:
		UE_LOG(LogTemp, Warning, TEXT("FIRE POTION"));
		potionCrafted = Fire;
		break;
	case 50012:
		UE_LOG(LogTemp, Warning, TEXT("ICE POTION"));
		potionCrafted = Ice;
		break;
	default:
		UE_LOG(LogTemp, Warning, TEXT("NOT A VALID POTION"));
		potionCrafted = Empty;
		wasValid = false;
		break;
	}

	if (potionsAvailable < 4) {
		//Increment number of potions available
		potionBacklog[potionsAvailable] = potionCrafted;
		if (wasValid) potionsAvailable++;
	}
	else {
		if (wasValid) {
			for (int i = 3; i > 0; i--) {
				potionBacklog[i] = potionBacklog[i - 1];
			}
			potionBacklog[0] = potionCrafted;
		}
	}
	//Reset Ingredient Array
	for (int i = 0; i < NumOfIngredients; i++)
	{
		IngredientArr[i] = 0;
	}
	for (int i = 0; i < potionsAvailable; i++) {
		if (potionBacklog[i] == Fire) {
			UE_LOG(LogTemp, Warning, TEXT("FirePot at: %d"), i);
		}
		if (potionBacklog[i] == Ice) {
			UE_LOG(LogTemp, Warning, TEXT("IcePot at: %d"), i);
		}
		if (potionBacklog[i] == Acid) {
			UE_LOG(LogTemp, Warning, TEXT("AcidPot at: %d"), i);
		}
	}
}

void UPotions::BacklogPop() {
	if (potionsAvailable != 0) {
		TEnumAsByte<FPotionTypes> temp = Empty, temp2;
			if (potionsAvailable == 1) {
				//empty first slot
				potionBacklog[0] = Empty;
				potionsAvailable--;
			}
			else {
				for (int i = potionsAvailable-1; i > 0; i--)
				{
					// i = 3
					//2nd slot (F) enters temp2
					//2nd slot is replaced with either 3rd if this isnt the first loop or with 3rd slot if it is
					//temp2 is moved into temp for next loop
					if (temp == Empty) potionBacklog[0] = Empty;
					temp2 = potionBacklog[i - 1];
					potionBacklog[i - 1] = (temp == Empty) ? potionBacklog[i] : temp;
					temp = temp2;
				}
				potionBacklog[potionsAvailable - 1] = Empty;
				potionsAvailable--;
			}
		UE_LOG(LogTemp, Warning, TEXT("%d Potions Available"), potionsAvailable)
		for (int i = 0; i < potionsAvailable; i++) {
			if (potionBacklog[i] == Fire) {
				UE_LOG(LogTemp, Warning, TEXT("FirePot at: %d"), i);
			}
			if (potionBacklog[i] == Ice) {
				UE_LOG(LogTemp, Warning, TEXT("IcePot at: %d"), i);
			}
			if (potionBacklog[i] == Acid) {
				UE_LOG(LogTemp, Warning, TEXT("AcidPot at: %d"), i);
			}
		}
	}
}

