// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "Kismet/KismetStringLibrary.h"
#include "Potions.generated.h"


UENUM(BlueprintType)
enum FPotionTypes {
	Empty,
	Fire,
	Ice,
	Acid
};

UCLASS( ClassGroup=(Custom), meta=(BlueprintSpawnableComponent) )
class FIVESTACKPOTIONGAME_API UPotions : public UActorComponent
{
	GENERATED_BODY()

		// Ingredients Implementation
		// Wood splinters, Gunpowder, Water, Snowflakes, Venom Sack
		// Enum list of ingredients
		// 5 bools? No wouldnt be able to have more than 1
		//Dictionary / Map? ID Key, potion created is combination of id 
		//int ids allow make more sense than maps, combine them to generate the potions, potions are made in descending order e.g 001 = fire potion
		//Better yet, array of ints each entry dictates how many of each ingredient is added so 2, 1, 0, 0, 0 = fire potion
		
public:	
	int potionsAvailable = 0;
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
	TArray<TEnumAsByte<FPotionTypes>> potionBacklog;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly)
	TArray<int> IngredientArr; //0 Wood splinters, 1 Sulphur, 2 Water, 3 Snowflakes
	// Sets default values for this component's properties
	UPotions();
	void CraftPotion();
	UFUNCTION(BlueprintCallable)
	void BacklogPop();


protected:
	// Called when the game starts
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction) override;
	void InitIngArr(int arrSize) { IngredientArr.Init(0, arrSize); }// Initialize with 5 zeros
};