// Fill out your copyright notice in the Description page of Project Settings.


#include "AIEnemy_Actor.h"
#include "AIEnemy_Controller.h"
#include "BehaviorTree/BlackboardComponent.h"

// Sets default values
AAIEnemy_Actor::AAIEnemy_Actor()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

	//Create root box component -- Collide with all --
	BoxComponent = CreateDefaultSubobject<UBoxComponent>(TEXT("Box Component"));
	RootComponent = BoxComponent;

	//Create attack collider -- Overlap --
	attackCollider = CreateDefaultSubobject<UBoxComponent>(TEXT("Attack Collider"));

	// Set defaults in editor. Create ice debuff function in C++ but make it blueprint callable.
	CharacterMovement = CreateDefaultSubobject<UCharacterMovementComponent>(TEXT("Character Movement")); 
	//
	//Cooldown and health will be set and altered in blueprint to easily test game
	//
}

// Called when the game starts or when spawned
void AAIEnemy_Actor::BeginPlay()
{
	Super::BeginPlay();

	
	Enemy_Controller->GetBlackboard()->SetValueAsBool("Idle", true);
}

// Called every frame
void AAIEnemy_Actor::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

}

int AAIEnemy_Actor::TakeDamage(int Damage)
{
	currentEnemyHealth -= Damage;
	return currentEnemyHealth;
}

float AAIEnemy_Actor::TakeDOT(float DOT, float DeltaTime)
{
	currentEnemyHealth -= DOT * DeltaTime;
	return currentEnemyHealth;
}

void AAIEnemy_Actor::setPlayerValue(AActor* Player)
{
	Enemy_Controller->GetBlackboard()->SetValueAsObject("Player", Player);
}

