// Fill out your copyright notice in the Description page of Project Settings.


#include "AIEnemy_Character.h"
#include "AIEnemy_Controller.h"
#include "FiveStackPotionGameCharacter.generated.h"
#include "Math/UnrealMathUtility.h"
#include "BehaviorTree/BlackboardComponent.h"

// Sets default values
AAIEnemy_Character::AAIEnemy_Character()
{
 	// Set this character to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
}

// Called when the game starts or when spawned
void AAIEnemy_Character::BeginPlay()
{
	Super::BeginPlay();
	bscreaming = false;
	
	Enemy_Controller = Cast<AAIEnemy_Controller>(GetController());
}

// Called every frame
void AAIEnemy_Character::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
	
}

// Called to bind functionality to input
void AAIEnemy_Character::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
	Super::SetupPlayerInputComponent(PlayerInputComponent);

}

int AAIEnemy_Character::TakeDamage(int Damage)
{
	currentEnemyHealth -= Damage;
	damageTaken = Damage;
	return currentEnemyHealth;
}

float AAIEnemy_Character::TakeDOT(float DOT, float DeltaTime)
{
	currentEnemyHealth -= DOT * DeltaTime;
	damageTaken = DOT * DeltaTime;
	return currentEnemyHealth;
}

void AAIEnemy_Character::chasePlayer(AActor* PlayerActor)
{
	AAIEnemy_Controller* OtherController = Cast<AAIEnemy_Controller>(GetController());
	OtherController->GetBlackboard()->SetValueAsObject("Player", PlayerActor);
}

