// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Components/BoxComponent.h"
#include "GameFramework/CharacterMovementComponent.h"
#include "AIEnemy_Actor.generated.h"

UCLASS()
class FIVESTACKPOTIONGAME_API AAIEnemy_Actor : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AAIEnemy_Actor();

	/* AI Controller */
	class AAIEnemy_Controller* Enemy_Controller;

	UPROPERTY(EditAnywhere, Category = "Pawn")
	class UBehaviorTree* BehaviorTree;
	
	/* Enemy Health */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float maxEnemyHealth;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float currentEnemyHealth;

	/* Enemy Attack */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float maxEnemyAttackCooldown;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float currentEnemyAttackCooldown;

	/* Box Component for dealing damage -- Overlap only -- */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyAttack")
	UBoxComponent* attackCollider;

	/* Enemy Movement */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "Character Movement")
	UCharacterMovementComponent* CharacterMovement;
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	/* Box Component for potion, environment, other enemies, player, etc, collision detection */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Collision")
	UBoxComponent* BoxComponent;

	/* Enemy taking damage */
	UFUNCTION(BlueprintCallable, Category = "Enemy Take Damage")
	int TakeDamage(int Damage);

	UFUNCTION(BlueprintCallable, Category = "Enemy Take Damage")
	float TakeDOT(float DOT, float DeltaTime);

	void setPlayerValue(AActor* Player);

	/* Enemy dealing damage */
	//Write function when player BP has been setup
};
