// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "Components/BoxComponent.h"
#include "AIEnemy_Character.generated.h"

UCLASS()
class FIVESTACKPOTIONGAME_API AAIEnemy_Character : public ACharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties
	AAIEnemy_Character();

	/* AI Controller */
	class AAIEnemy_Controller* Enemy_Controller;

	UPROPERTY(EditAnywhere, Category = "Pawn")
	class UBehaviorTree* BehaviorTree;
	
	/* Enemy Health */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float maxEnemyHealth;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float currentEnemyHealth;

	/* Enemy Attack */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float maxEnemyAttackCooldown;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float currentEnemyAttackCooldown;

	/* Box Component for dealing damage -- Overlap only -- */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyAttack")
	UBoxComponent* attackCollider;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyScream")
	bool bscreaming;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite)
		float damageTaken = 0;

	UPROPERTY(VisibleAnywhere, BlueprintReadWrite)
		float dmgResetTimer = 0;
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

	/* Enemy taking damage */
	UFUNCTION(BlueprintCallable, Category = "Enemy Take Damage")
	int TakeDamage(int Damage);

	UFUNCTION(BlueprintCallable, Category = "Enemy Take Damage")
	float TakeDOT(float DOT, float DeltaTime);

	UFUNCTION()
	void chasePlayer(AActor* PlayerActor);


	/* Enemy dealing damage */
	//Write function when player BP has been setup
};
