// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "AIController.h"
#include "Perception/AISenseConfig_Sight.h"
#include "AIEnemy_Controller.generated.h"

/**
 * AI Enemy controller
 */
UCLASS()
class FIVESTACKPOTIONGAME_API AAIEnemy_Controller : public AAIController
{
	GENERATED_BODY()
	
public:
	AAIEnemy_Controller();

	virtual void OnPossess(APawn* InPawn) override;

	UBlackboardComponent* GetBlackboard();

	//Setup AI perception
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "AI Perception")
	UAIPerceptionComponent* PerceptionComp;

	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = "AI Perception")
	UAISenseConfig_Sight* SenseConfig_Sight;

	UFUNCTION()
	void OnPawnDetect(const	TArray<AActor*>&DetectedPawn);

	UFUNCTION()
	void AlertEnemies(AActor* PlayerActor);

	
protected:

	UPROPERTY(BlueprintReadWrite, Category = "Behaviour")
	class UBlackboardComponent* BlackboardComponent;

	UPROPERTY(BlueprintReadWrite, Category = "Behaviour")
	class UBehaviorTreeComponent* BehaviorTreeComponent;

	UPROPERTY()
	class AAIEnemy_Character* Enemy;

public:
	// Called every frame
	virtual void Tick(float DeltaTime) override;
};
