// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Pawn.h"
#include "Components/BoxComponent.h"
#include "AIEnemy_Pawn.generated.h"

UCLASS()
class FIVESTACKPOTIONGAME_API AAIEnemy_Pawn : public APawn
{
	GENERATED_BODY()

public:
	// Sets default values for this pawn's properties
	AAIEnemy_Pawn();

	/* AI Controller */
	class AAIEnemy_Controller* Enemy_Controller;

	/* Enemy Health */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float maxEnemyHealth;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyHealth")
	float currentEnemyHealth;

	/* Enemy Attack */
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float maxEnemyAttackCooldown;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "EnemyAttack")
	float currentEnemyAttackCooldown;

	/* Box Component for dealing damage -- Overlap only -- */
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "EnemyAttack")
	UBoxComponent* attackCollider;
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

	/* Box Component for potion, environment, other enemies, player, etc, collision detection */
	UPROPERTY()
		UBoxComponent* BoxComponent;
	UPROPERTY()
		USkeletalMesh* SkeletalMesh;		
};
